import es, playerlib, time, random, usermsg, gamethread

#################
# Configuration #
#################

# How long until detonation. Best to stick with 3 seconds.
dettime = 3

#################
# End of Config #
#################

ready = 0
pinpulled = []
timer = {}
es.ServerVar("nadetimer_ver", "1.0", "Version of NadeTimer this server is running.").makepublic()

def load():
    es.addons.registerTickListener(GrenadeTicker)
    es.server.cmd("est_enable_PerUserKeyEvents 1")
    setReady()
    es.server.cmd('est_RegEventBlock player_death "es_xdoblock nadetimer/PlayerDeath"')

def unload():
    es.addons.unregisterTickListener(GrenadeTicker)
    es.server.cmd("est_enable_PerUserKeyEvents 0")
    gamethread.cancelDelayed("ready")
    es.server.cmd('est_unRegEventBlock player_death "es_xdoblock nadetimer/PlayerDeath"')

def est_client_keypress(event_var):
    if event_var["keyname"] == "attack":
        if playerlib.getPlayer(event_var["userid"]).get("weapon") == "weapon_hegrenade" and ready == 1:
            if event_var["status"] == "1": pinpulled.append(event_var["userid"])

def GrenadeTicker():
    try:
        ownerlist = {}
        entlist = es.createentitylist("hegrenade_projectile")
        for index in entlist: ownerlist[getOwner(index)] = index
        for userid in pinpulled:
            if not es.getplayersteamid(userid) == "BOT":
                if playerlib.getPlayer(userid).get("weapon") == "weapon_hegrenade" or userid in ownerlist:
                    if not userid in timer: timer[userid] = time.time()
                    curtime = time.time() - timer[userid]
                    if curtime >= 1: usermsg.hudhint(userid, "-[DETONATION IN %.2f]-" % (dettime+1 - curtime))
                    if curtime >= dettime+1:
                        if userid in ownerlist: Detonate(userid, index)
                        else: Detonate(userid)
                elif userid in pinpulled: resetPin(userid)
    except: pass

def resetPin(userid):
    try:
        pinpulled.remove(userid)
        del timer[userid]
    except: pass

def getOwner(index):
    return str(es.getuserid(es.getindexprop(index, "CBaseGrenade.m_hThrower")))

def Detonate(userid, index=None):
    resetPin(userid)
    usermsg.hudhint(userid, "-[DETONATED]-")
    if index: loc = es.getindexprop(index, "CBaseEntity.m_vecOrigin").split(",")
    else: loc = es.getplayerprop(userid, "CBaseEntity.m_vecOrigin").split(",")
    ammo = getAmmo(userid)
    if index:
        es.emitsound("entity", index, "weapons\explode%d.wav" % random.randint(3,5), 1, 0.60)
        es.server.cmd("es_xremove %d" % index)
    else: es.emitsound("player", userid, "weapons\explode%d.wav" % random.randint(3,5), 1, 0.60)
    es.server.cmd("es_xgive %s env_explosion" % userid)
    explosion = es.ServerVar("eventscripts_lastgive")
    if index:
        es.setindexprop(index, "CBaseEntity.m_vecOrigin", "%s,%s,%s" % (loc[0], loc[1], loc[2]))
        es.server.cmd('es_xfire %s env_explosion addoutput "origin %s %s %s"' % (userid, loc[0], loc[1], loc[2]))
    es.server.cmd('es_fire %s env_explosion addoutput "imagnitude 100"' % userid)
    es.server.cmd('es_fire %s env_explosion addoutput "iradiusoverride 350"' % userid)
    es.setindexprop(explosion, "CBaseEntity.m_hOwnerEntity", es.getplayerhandle(userid))
    if es.ServerVar("mp_friendlyfire") == 0: es.setindexprop(explosion, "CBaseEntity.m_iTeamNum", es.getplayerteam(userid))
    es.server.cmd("es_fire %s env_explosion Explode" % userid)
    setAmmo(userid, ammo)
    if not index: removeGrenade(userid)

def removeGrenade(userid):
    es.server.cmd("est_removeweapon %s weapon_hegrenade" % userid)

def getAmmo(userid):
    player = playerlib.getPlayer(userid)
    return {0: player.get("ammo", "1"), 1: player.get("ammo", "2"), 2: player.get("clip", "1"), 3: player.get("clip", "2")}

def setAmmo(userid, ammo):
    player = playerlib.getPlayer(userid)
    try:
        player.set("ammo", ("1", ammo[0]))
        player.set("ammo", ("2", ammo[1]))
        player.set("clip", ("1", ammo[2]))
        player.set("clip", ("2", ammo[3]))
    except: pass

def setReady():
    global ready
    ready = 1

def hegrenade_detonate(event_var):
    try:
        usermsg.hudhint(event_var["userid"], "-[EARLY DETONATION!]-")
        pinpulled.remove(event_var["userid"])
        del timer[event_var["userid"]]
    except: pass

def round_start(event_var):
    global ready
    ready = 0
    gamethread.delayedname(es.ServerVar("mp_freezetime"), "ready", setReady)
    es.msg("#multi", "#green[NadeTimer] #lightgreenFrag Grenades #defaultwill explode in your hand if held for too long!")

def round_end(event_var):
    gamethread.cancelDelayed("ready")
    for userid in playerlib.getUseridList("#all"): resetPin(str(userid))

def PlayerDeath():
    weapon = es.ServerVar("nt_weapon", 0)
    es.server.cmd("est_geteventinfo nt_weapon weapon")
    if weapon == "env_explosion": es.server.cmd("est_seteventinfo weapon hegrenade")